#!/usr/bin/env node
'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _defaultOptions = require('./defaultOptions');

var _defaultOptions2 = _interopRequireDefault(_defaultOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_asyncToGenerator(function* () {
  _commander2.default
  // package.json is one level up because the compiled js file is in lib/
  // eslint-disable-next-line import/no-unresolved
  .version(require(_path2.default.resolve(__dirname, '../package.json')).version).usage('[options] <file> [arg1 arg2 ...]').description('Runs an Elm file and prints the result of `output` to stdout.' + ' `output` can be a constant of type `String` or a function that accepts `List String` and returns `String`. You can supply command line arguments to the Elm file if `output` accepts `List String`.').option('--output-name [name]', 'constant or function name for printing results', _defaultOptions2.default.outputName).option('--project-dir [path]', 'specific directory to search for elm-package.json or to create it (if different from Elm file location)').option('--report [format]', 'format of error and warning reports (e.g. --report=json)', _defaultOptions2.default.report).option('--path-to-elm-make [path]', 'location of `elm-make` binary (if not defined, a globally available `elm-make` is used)').parse(process.argv);

  // run-elm expects one or more arguments, so exit if no arguments given
  if (_commander2.default.args.length === 0) {
    console.log(_commander2.default.help());
    process.exit(1);
  }

  try {
    var _ref2 = yield (0, _index2.default)(_commander2.default.args[0], {
      outputName: _commander2.default.outputName,
      projectDir: _commander2.default.projectDir,
      report: _commander2.default.report,
      pathToElmMake: _commander2.default.pathToElmMake,
      argsToOutput: _commander2.default.args.slice(1)
    });

    const debugLog = _ref2.debugLog,
          output = _ref2.output;

    if (debugLog.length) {
      console.log(debugLog.join('\n'));
    }
    console.log(output);
  } catch (e) {
    console.error('Error:', e.message);
    if (e.stack && process.env.DEBUG) {
      console.error(e.stack.substring(e.toString().length + 1));
    }
    process.exit(1);
  }
})();